# -*- rpm-spec -*-
# $Id: avr-gcc,v 1.2 2002/10/28 16:13:50 grigory Exp $

%define cross_arch avr

Summary: GNU Compiler for AVR (C language only).
Name: %cross_arch-gcc
Version: 3.0.4
Release: alt1

Copyright: GPL
Group: Development/Other
URL: http://gcc.gnu.org

Source0: gcc-core-%version.tar.bz2
Source1: gcc-g++-%version.tar.bz2
Patch0: gcc-avr-macro-fix.patch
Patch1: gcc-avr-info-fix.patch
Patch2: gcc-3.0.4-patch128
Patch3: gcc-3.0.4-patchc++

# Automatically added by buildreq on Thu Oct 24 2002
BuildRequires: avr-binutils flex

BuildRequires: avr-binutils >= 2.11.2-alt1
BuildRequires: zlib-devel
Requires: avr-binutils >= 2.11.2-alt1
Prereq: /sbin/install-info

%define libavrdir %_libdir/%cross_arch
%define includeavrdir %_includedir/%cross_arch


%description
The avr-gcc package contains the GNU Compiler Collection version 3.0 for the
Atmel AVR target.

%package c++
Summary: C++ support for gcc for AVR
Group: Development/Other
Requires: avr-gcc = %version-%release

%description c++
This package adds C++ support to the GNU C compiler version 3.0 for the Atmel
AVR target.

WARNING - This is still fairly experimental and only supports c++ programming
on the mega128 devices.


%prep
# Unpack the core source
%setup -q -n gcc-%version

# Unpack the g++ source
%setup -q -T -D -b 1 -n gcc-%version
%patch0 -p1 -b .avr-macro-fix
%patch1 -p1 -b .avr-info-fix
%patch2 -p1 -b .mega128
%patch3 -p1 -b .patchc++

cd %_builddir/gcc-%version/gcc


%build
# %__subst "s|\(tooldir='\$(exec_prefix)'/\)\${target_alias}|\1lib/\${target_alias}|" configure
# %__subst "s|\(tooldir = \$(exec_prefix)/\)\$(target_alias)|\1lib/\$(target_alias)|" Makefile.in
echo "" > gcc/cp/g++.1

%__rm -fr obj-avr-%_target_platform
%__mkdir obj-avr-%_target_platform
cd obj-avr-%_target_platform

%remove_optflags %optflags_nocpp %optflags_notraceback
CC="$CC" \
        CFLAGS="$RPM_OPT_FLAGS" \
        CXXFLAGS="$RPM_OPT_FLAGS" \
        GCJFLAGS="$RPM_OPT_FLAGS" \
        XCFLAGS="$RPM_OPT_FLAGS" \
        TCFLAGS="$RPM_OPT_FLAGS" \
	../configure \
		--target=%cross_arch \
		--host=%_target_platform \
		--enable-languages="c,c++" \
		--disable-nls \
		--enable-target-optspace \
		--includedir=%includeavrdir \
		--prefix=%_prefix \
		--exec-prefix=%_libdir/avr \
		--mandir=%_mandir \
		--infodir=%_infodir
#		--with-as=%libavrdir/bin/as \
#		--with-ld=%libavrdir/bin/ld
%make_build


%install
%__mkdir_p %buildroot%_bindir
cd obj-avr-%_target_platform
# TARGET_PLATFORM=%_target_platform
echo timestamp > gcc/cstamp-h

%make_build \
	prefix=%buildroot%_prefix \
	exec_prefix=%buildroot%_libdir \
	libdir=%buildroot%_libdir/avr \
	includedir=%buildroot%includeavrdir \
	mandir=%buildroot%_mandir \
	infodir=%buildroot%_infodir install

rename cpp.1 %cross_arch-cpp.1 %buildroot%_man1dir/*
rename gcov.1 %cross_arch-gcov.1 %buildroot%_man1dir/*
%__rm -f %buildroot%_man1dir/%cross_arch-g++*
# %__ln_s ../../../../..%_bindir/%cross_arch-as %buildroot%_libdir/gcc-lib/%cross_arch/%version/as

%__mv %buildroot%_libdir/bin/* %buildroot%_bindir/
%__ln_s -f %cross_arch-gcc.1.bz2 %buildroot%_man1dir/%cross_arch-g++.1.bz2
%__ln_s -f %cross_arch-c++ %buildroot%_bindir/%cross_arch-g++

%__mv %buildroot%_bindir/gccbug %buildroot%_bindir/%cross_arch-gccbug
%__mv %buildroot%_bindir/gcov %buildroot%_bindir/%cross_arch-gcov

%files
%doc gcc/README* gcc/*ChangeLog*
%_bindir/*-cpp
%_bindir/*-gcc*
%_bindir/*-gcov
# %libavrdir/gcc-lib/%cross_arch/%version/as
%libavrdir/gcc-lib/%cross_arch/%version/avr*
%libavrdir/gcc-lib/%cross_arch/%version/include*
%libavrdir/gcc-lib/%cross_arch/%version/cc1
%libavrdir/gcc-lib/%cross_arch/%version/collect2
%libavrdir/gcc-lib/%cross_arch/%version/cpp0
%libavrdir/gcc-lib/%cross_arch/%version/libgcc.a
%libavrdir/gcc-lib/%cross_arch/%version/specs
%libavrdir/gcc-lib/%cross_arch/%version/tradcpp0
# %libavrdir/libiberty.a
%_man1dir/*-gcc.1*
%_man1dir/*-cpp.1*
%_man1dir/*-gcov.1*
%_infodir/*

%files c++
%_bindir/*-*++*
%libavrdir/gcc-lib/%cross_arch/%version/cc1plus
%_man1dir/*-g++.1*


%changelog
* Thu Oct 24 2002 Grigory Milev <week@altlinux.ru> 3.0.4-alt1
- Initial build for ALT Linux

* Tue Mar 17 2002 Theodore A. Roth <troth@verinet.com>
- Initial spec file.
